<template>
  <div class="edit-project">
    <form @submit.prevent="submit">
      <div class="form-field search-user">
        <div class="col-12 md:col-4">
          <div class="p-inputgroup">
            <prime-input-text v-model="keywordInput" placeholder="Введите ключевое слово" />
            <prime-button
              type="submit"
              label="Добавить"
            />
          </div>
        </div>
      </div>
    </form>

    <div>
      <div
        v-for="keyword in keywords"
        :key="keyword.id"
        class="keyword"
      >
        <edit-keyword
          :keyword-groups="keywordGroups"
          :keyword="keyword"
          @create-relation="$emit('create-relation', $event)"
          @delete-relation="$emit('delete-relation', $event)"
          @delete="deleteKeyword(keyword)"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent, PropType } from 'vue';
import { createKeyword, deleteKeyword } from '@/api/handler/keywords';
import { KeywordGroup } from '@/models/keywordGroup';
import { Keyword } from '@/models/keywords';
import { Project } from '@/models/projects';
import EditKeyword from './EditKeyword.vue';

interface Data {
  keywordInput: string;
}

export default defineComponent({
  name: 'edit-keywords',
  components: {
    PrimeButton,
    PrimeInputText,
    EditKeyword,
  },
  props: {
    keywords: { type: Array as PropType<Keyword[]>, required: true },
    keywordGroups: { type: Array as PropType<KeywordGroup[]>, required: true },
    project: { type: Object as PropType<Project>, required: true },
  },
  emits: ['close', 'add', 'delete', 'delete-relation', 'create-relation'],
  data(): Data {
    return {
      keywordInput: '',
    };
  },
  methods: {
    async submit() {
      if (this.keywordInput === '') {
        return;
      }
      const res = await createKeyword({ value: this.keywordInput, projectId: this.project.id });
      if (res.__state === 'success') {
        this.keywordInput = '';
        this.$emit('add', res.data);
      }
    },
    async deleteKeyword({ id }: Keyword) {
      const res = await deleteKeyword({ id });
      if (res.__state === 'success') {
        this.$emit('delete', id);
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}

.keyword {
    display: flex;
    align-items: center;

    &__email {
        flex: 1 1 auto;
    }
}
</style>
